<?php
/**
 * @version		$Id: externalfavicon.php 20196 2011-03-04 02:40:25Z mrichey $
 * @package		plg_sys_externalfavicon
 * @copyright	Copyright (C) 2005 - 2012 Michael Richey. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgSystemExternalFavicon extends JPlugin
{

        function onAfterRoute()
	{
                $app = JFactory::getApplication();
                
                // do we run in administrator ?
                if($app->isAdmin()) return true;
                
                $doc = JFactory::getDocument();

                // we don't run in pages that aren't html
                if($doc->getType() != 'html') return true;

                // we don't run in incomplete pages
                if(JRequest::getString('tmpl') == 'raw') return true;

                // do we run in the component template?
                if(!$this->params->get('runincomponent',1)) {
                    if(JRequest::getString('tmpl') == 'component') return true;
                }

                $ai=array();
                $alternateimages = trim($this->params->get('alternateimages',false));
                if($alternateimages) {
                    $alternateimages = explode("\n",$alternateimages);
                    foreach($alternateimages as $i) {
                        $i=explode(':',trim($i));
                        if(count($i==2)) $ai[$i[0]]=$i[1];
                    }
                }
                $ai = count($ai)?json_encode($ai):'{}';

                $ed=array();
                $excludedomains = trim($this->params->get('excludedomains',false));
                if($excludedomains) {
                    $excludedomains = explode("\n",$excludedomains);
                    foreach($excludedomains as $key=>$ed) {
                        if(strlen(trim($ed))) {
                            $ei[]=trim($ed);
                        }
                    }
                }
                $ed = count($ed)?json_encode($ed):'[]';

                $ei=array();
                $excludeids = trim($this->params->get('excludeids',false));
                if($excludeids) {
                    $excludeids = explode("\n",$excludeids);
                    foreach($excludeids as $key=>$id) $ei[$key]=trim($id);
                }
                $ei = count($ei)?json_encode($ei):'[]';

                // sweet - it's on!
                JHtml::_('behavior.framework',true);
                
                // include the basic mootools plugin
                $doc->addScript(JURI::root(true).'/media/plg_system_externalfavicon/Mootools-External-Favicon.js');
                $script=array();
                $script[]="var plg_system_externalfavicon = false;";
                $script[]="window.addEvent('domready',function(){";
                $script[]="\tif(!plg_system_externalfavicon) {";
                $script[]="\t\tdocument.body.getFavicons('','',".$ed.",".$ai.",".$ei.");";
                $script[]="\t\tplg_system_externalfavicon = true;";
                $script[]="\t}";
                $script[]="});";
                $doc->addScriptDeclaration(implode("\n",$script));
		return true;
	}
}